package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.WFUCPolicy;
import com.sa.ibiz.demo.demo.service.WFUCPolicyService;
import com.sa.ibiz.demo.demo.service.dto.WFUCPolicySearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/wfucpolicy")
public class WFUCPolicyResource
{
	@Autowired
	private WFUCPolicyService service;


	@PostMapping(value = "/enablePolicy")
	public ResponseEntity<WFUCPolicy> enablePolicy(@Validated @RequestBody WFUCPolicy data){
		service.enablePolicy(data);
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<WFUCPolicy> update(@Validated @RequestBody WFUCPolicy data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流候选用户策略[update]操作发生错误","WFUCPolicy",data.getWfucpolicyid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<WFUCPolicy> getDraft(@Validated @RequestBody WFUCPolicy data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流候选用户策略[getDraft]操作发生错误","WFUCPolicy","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<WFUCPolicy> create(@Validated @RequestBody WFUCPolicy data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流候选用户策略[create]操作发生错误","WFUCPolicy",data.getWfucpolicyid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<WFUCPolicy> get(@Validated @PathVariable String id){
		WFUCPolicy data=new WFUCPolicy();
		data.setWfucpolicyid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("工作流候选用户策略[get]操作发生错误","WFUCPolicy",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<WFUCPolicy> remove(@Validated @RequestBody WFUCPolicy data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流候选用户策略[remove]操作发生错误","WFUCPolicy",data.getWfucpolicyid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<WFUCPolicy> checkKey(@Validated @RequestBody WFUCPolicy data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流候选用户策略[checkKey]操作发生错误","WFUCPolicy",data.getWfucpolicyid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/disablePolicy")
	public ResponseEntity<WFUCPolicy> disablePolicy(@Validated @RequestBody WFUCPolicy data){
		service.disablePolicy(data);
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<WFUCPolicy>> searchDefaultPage(@Validated @RequestBody WFUCPolicySearchFilter filter){
		Page<WFUCPolicy> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<WFUCPolicy>> listDefault(@Validated @RequestBody WFUCPolicySearchFilter filter){
		List<WFUCPolicy> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
